% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genericMethods.R, R/classesComp.R,
%   R/FLIndexBiomass.R
\docType{class}
\name{FLIndexBiomass}
\alias{FLIndexBiomass}
\alias{FLIndexBiomass-methods}
\alias{FLIndexBiomass}
\alias{FLIndexBiomass-class}
\alias{catch.n,FLIndexBiomass-method}
\alias{catch.wt,FLIndexBiomass-method}
\alias{desc,FLIndexBiomass-method}
\alias{distribution,FLIndexBiomass-method}
\alias{effort,FLIndexBiomass-method}
\alias{index,FLIndexBiomass-method}
\alias{index.q,FLIndexBiomass-method}
\alias{index.var,FLIndexBiomass-method}
\alias{name,FLIndexBiomass-method}
\alias{range,FLIndexBiomass-method}
\alias{sel.pattern,FLIndexBiomass-method}
\alias{catch.n<-,FLIndexBiomass,FLQuant-method}
\alias{catch.n<-,FLIndexBiomass,numeric-method}
\alias{catch.wt<-,FLIndexBiomass,FLQuant-method}
\alias{catch.wt<-,FLIndexBiomass,numeric-method}
\alias{desc<-,FLIndexBiomass,character-method}
\alias{distribution<-,FLIndexBiomass,character-method}
\alias{effort<-,FLIndexBiomass,FLQuant-method}
\alias{index<-,FLIndexBiomass,FLQuant-method}
\alias{index<-,FLIndexBiomass,numeric-method}
\alias{index.q<-,FLIndexBiomass,FLQuant-method}
\alias{index.q<-,FLIndexBiomass,numeric-method}
\alias{index.var<-,FLIndexBiomass,FLQuant-method}
\alias{index.var<-,FLIndexBiomass,numeric-method}
\alias{name<-,FLIndexBiomass,character-method}
\alias{range<-,FLIndexBiomass,numeric-method}
\alias{sel.pattern<-,FLIndexBiomass,FLQuant-method}
\alias{sel.pattern<-,FLIndexBiomass,numeric-method}
\alias{FLIndexBiomass,FLQuant-method}
\alias{FLIndexBiomass,missing-method}
\title{Class FLIndexBiomass}
\usage{
FLIndexBiomass(object, ...)

\S4method{FLIndexBiomass}{FLQuant}(object, plusgroup = dims(object)$max, ...)

\S4method{FLIndexBiomass}{missing}(object, ...)
}
\arguments{
\item{object}{FLQuant object used for sizing}

\item{...}{Other objects to be assigned by name to the class slots}
}
\description{
A class for modelling biomass indices.
}
\details{
The \code{FLIndexBiomass} object holds data and parameters related to
biomass indices.
}
\section{Slots}{
 \describe{ \item{distribution}{Statistical distribution of
the index values (\code{character}).} \item{index}{Index values
(\code{FLQuant}).} \item{index.var}{Variance of the index (\code{FLQuant}).}
    \item{catch.n}{Catch numbers used to create the index (\code{FLQuant}).}
    \item{catch.wt}{Catch weight of the index (\code{FLQuant}).}
    \item{effort}{Effort used to create the index (\code{FLQuant}).}
    \item{sel.pattern}{Selection pattern for the index (\code{FLQuant}).}
    \item{index.q}{Catchability of the index (\code{FLQuant}).}
    \item{name}{Name of the stock (\code{character}).}
    \item{desc}{General description of the object (\code{character}).}
    \item{range}{Range of the object (\code{numeric})}
}
}

\section{Accessors}{

All slots in the class have accessor and replacement methods defined that
allow retrieving and substituting individual slots.

The values passed for replacement need to be of the class of that slot.
A numeric vector can also be used when replacing FLQuant slots, and the
vector will be used to substitute the values in the slot, but not its other
attributes.
}

\section{Constructor}{

A construction method exists for this class that can take named arguments for
any of its slots. All slots are then created to match the requirements of the
class validity. If an unnamed \code{FLQuant} object is provided, this is used
for sizing but not stored in any slot.
}

\section{Validity}{
 \describe{
    \item{Dimensions}{All FLQuant slots must have iters equal to 1 or 'n'.}
    \item{Iters}{The dimname for iter[1] should be '1'.}
    \item{Dimnames}{The name of the quant dimension must be the same for all FLQuant slots.}
}
}

\examples{

idx <- FLIndexBiomass(index=FLQuant(1:10, quant='age'))

data(ple4)
ida <- FLIndexBiomass(index=ssb(ple4),
  catch.n=catch.n(ple4))

}
\seealso{
\link{computeCatch}, \link{dims},
\link{iter}, \link[graphics]{plot}, \link{propagate}, \link[base]{summary},
\link[base]{transform}, \link{trim}, \link[stats]{window}, \link{FLComp}
}
\author{
The FLR Team
}
\keyword{classes}
